import { world, system } from "@minecraft/server";
import { HammerBreak } from "./impl/exports";
import { getItemsWithTag } from "./functions";
import { EntityInventoryComponent } from "@minecraft/server";

world.beforeEvents.playerBreakBlock.subscribe(event => {
  const { player, block, itemStack } = event;

  if (player.isSneaking) return;
  HammerBreak.execute(itemStack, player, block);  
});

system.runInterval(() => {
  for (const player of world.getPlayers()) {
    getItemsWithTag(player, "minecraft:is_pickaxe").forEach(item => {
      const playerInventoryComponentContainer = player.getComponent(EntityInventoryComponent.componentId).container;
      
      item.item.setLore([ "§r§3 Veinminer" ]);
      playerInventoryComponentContainer.setItem(item.slot, item.item);
    });
  }
}, 0);

system.beforeEvents.watchdogTerminate.subscribe(event => event.cancel = true);